# -*- coding: utf-8 -*-
import libmediathek3 as libMediathek
import xbmc
import xbmcplugin
import xbmcaddon
import libwdr
import re

translation = xbmcaddon.Addon().getLocalizedString
icon = xbmc.translatePath(xbmcaddon.Addon().getAddonInfo('path')+'/icon.png')
xml = 'https://www.wdrmaus.de/_export/videositemap.php5'

def main():
	l = []
	l.append({'name':'Sachgeschichten', 'mode':'listVideos', '_type':'dir', 'thumb':icon, 'fanart':''})
	l.append({'name':'Lachgeschichten', 'mode':'listVideos', '_type':'dir', 'thumb':icon, 'fanart':''})
	l.append({'name':'Mausspots', 'mode':'listVideos', '_type':'dir', 'thumb':icon, 'fanart':''})
	l.append({'name':'Lieder', 'mode':'listVideos', '_type':'dir', 'thumb':icon, 'fanart':''})
	#names = []
	#response = libMediathek.getUrl(xml)
	#categories = re.compile('<video:category>(.+?)</video:category>', re.DOTALL).findall(response)
	#for cat in categories:
	#	if not cat in names:
	#		l.append({'name':cat, 'mode':'listVideos', '_type':'dir'})
	#		names.append(cat)
	return l

def listVideos():
	xbmcplugin.addSortMethod(int(sys.argv[1]), xbmcplugin.SORT_METHOD_LABEL)
	l = []
	response = libMediathek.getUrl(xml)
	videos = re.compile('<url>(.+?)</url>', re.DOTALL).findall(response)
	for video in videos:
		#libMediathek.log(video)
		if params['name'] == re.compile('<video:category>(.+?)</video:category>', re.DOTALL).findall(video)[0]:
			d = {}
			d['name'] = re.compile('<video:title><!\[CDATA\[(.+?)\]\]></video:title>', re.DOTALL).findall(video)[0].replace('![CDATA[','').replace(']]','').strip()
			d['_thumb'] = re.compile('<video:thumbnail_loc><!\[CDATA\[(.+?)\]\]></video:thumbnail_loc>', re.DOTALL).findall(video)[0].replace('![CDATA[','').replace(']]','').replace('_256.','_904.').strip()
			if not d['_thumb'].startswith('http'):
				d['_thumb'] = 'https:'+d['_thumb']
			d['url'] = re.compile('<video:player_lo.+?><!\[CDATA\[(.+?)\]\]></video:player_loc>', re.DOTALL).findall(video)[0].replace('![CDATA[','').replace(']]','').strip()
			d['_type'] = 'video'
			d['mode'] = 'libWdrPlayJs'
			libMediathek.log(str(d))
			l.append(d)
	return l

modes = {
'main': main,
'listVideos': listVideos,
}

def list():
	global params
	params = libMediathek.get_params()
	global pluginhandle
	pluginhandle = int(sys.argv[1])
	mode = params.get('mode','main')
	if mode.startswith('libWdr'):
		libwdr.list()
	else:
		l = modes.get(mode)()
		libMediathek.addEntries(l)
		xbmcplugin.endOfDirectory(int(sys.argv[1]),cacheToDisc=True)
list()